Index: /main/waeup.sirp/trunk/src/waeup/sirp/authentication.txt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/authentication.txt	(revision 6684)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/authentication.txt	(revision 6685)
@@ -158,5 +158,5 @@
 
   >>> browser.open('http://localhost/app')
-  >>> browser.getLink('Staff Login').click()
+  >>> browser.getLink('Login').click()
   >>> print browser.headers['Status']
   200 Ok
@@ -201,5 +201,5 @@
   >>> print browser.contents
   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
-  ...Staff Login
+  ...Login</a></div>
   ...
 
Index: in/waeup.sirp/trunk/src/waeup/sirp/browser/templates/login.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/login.pt	(revision 6684)
+++ 	(revision )
@@ -1,7 +1,0 @@
-<div class="portlet" 
-     tal:condition="python: request.principal.id == 'zope.anybody'">
-    
-    <a href="@@loginstaff">
-      Staff Login
-    </a>
-</div>
Index: in/waeup.sirp/trunk/src/waeup/sirp/browser/templates/loginstaffpage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/loginstaffpage.pt	(revision 6684)
+++ 	(revision )
@@ -1,50 +1,0 @@
-<div class="portlet" 
-     tal:condition="python: request.principal.id == 'zope.anybody'">
-    <h3>Staff Login</h3>
-    <div>
-      You've chosen the the portal's 'back entrance' to log in. This
-      entrance is dedicated to university staff members to maintain
-      the portal's database.
-    </div>
-    <form method="post">
-
-      <table id="login" class="form" 
-	     summary="Table for entering login information">
-	<tbody>
-	  <tr>
-	    <th>
-	      <label for="form.login">User Name</label>
-	    </th>
-	    <td>
-	      <input type="text" id="login" name="form.login" size="20" />
-	    </td>
-	  </tr>
-
-	  <tr>
-	    <th>
-	      <label for="form.password">Password
-	    </label>
-	    </th>
-	    <td>
-	      <input type="password" id="password" name="form.password"
-		     size="20" value="" />
-	      &nbsp;&nbsp; 
-	      <font color="red">
-		Notice: Passwords are case sensitive.
-	      </font>   
-	    </td>
-	  </tr>
-	</tbody>
-      </table>
-
-      <!-- input type="hidden" name="camefrom" 
-	     tal:attributes="value view/camefrom or nothing" / -->
-
-      <input type="submit" name="SUBMIT" value="Login" />
-
-      <p>Don't forget to logout or exit your browser when you're done.</p>
-      <p>If you are having trouble logging in, make sure to enable
-      cookies in your web browser.</p>
-
-    </form>
-</div>
Index: in/waeup.sirp/trunk/src/waeup/sirp/browser/templates/loginstudentpage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/loginstudentpage.pt	(revision 6684)
+++ 	(revision )
@@ -1,67 +1,0 @@
-<div class="portlet" 
-     tal:condition="python: request.principal.id == 'zope.anybody'">
-    <h3>Student Login</h3>
-    <p>
-      To access the registration portal enter your Student Id and
-      Password.
-    </p>
-    <p>
-      The <strong>Student Id</strong> (initial capital letter followed
-      by 6 numbers) has been automatically assigned by the portal
-      after creation of the student record. Do not confuse with your
-      Registration or Matriculation Number!
-    </p>
-  
-    <p>
-      During the admission and clearance process the
-      <strong>Password</strong> corresponds with the last 10 digits of
-      your Admission Checking PIN (prefix APP).
-    </p>
-
-    <div>
-      You've chosen the the portal's 'back entrance' to log in. This
-      entrance is dedicated to university staff members to maintain
-      the portal's database.
-    </div>
-    <form method="post">
-
-      <table id="login" class="form" 
-	     summary="Table for entering login information">
-	<tbody>
-	  <tr>
-	    <th>
-	      <label for="form.login">User Name</label>
-	    </th>
-	    <td>
-	      <input type="text" id="login" name="form.login" size="20" />
-	    </td>
-	  </tr>
-
-	  <tr>
-	    <th>
-	      <label for="form.password">Password
-	    </label>
-	    </th>
-	    <td>
-	      <input type="password" id="password" name="form.password"
-		     size="20" value="" />
-	      &nbsp;&nbsp; 
-	      <font color="red">
-		Notice: Passwords are case sensitive.
-	      </font>   
-	    </td>
-	  </tr>
-	</tbody>
-      </table>
-
-      <!-- input type="hidden" name="camefrom" 
-	     tal:attributes="value view/camefrom or nothing" / -->
-
-      <input type="submit" name="SUBMIT" value="Login" />
-
-      <p>Don't forget to logout or exit your browser when you're done.</p>
-      <p>If you are having trouble logging in, make sure to enable
-      cookies in your web browser.</p>
-
-    </form>
-</div>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/viewlets.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/viewlets.py	(revision 6684)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/viewlets.py	(revision 6685)
@@ -265,9 +265,15 @@
     grok.view(Interface)
     grok.order(2)
-
-    def isAuthenticated(self):
-        """Is the calling user authenticated?
-        """
-        return self.request.principal.id != 'zope.anybody'
+    grok.require('waeup.Anonymous')
+    text = 'Login'
+    link = 'login'
+
+    def render(self):
+        if self.request.principal.id != 'zope.anybody':
+            return ''
+        url = self.view.url(grok.getSite(), self.link)
+        return u'<div class="portlet"><a href="%s">%s</a></div>' % (
+                url, self.text)
+
 
 class ManageLink(grok.Viewlet):