Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 6689)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 6690)
@@ -124,4 +124,7 @@
     #: An instance of the default theme to use for the site layout
     default_theme = WAeUPThemeGray1()
+    stafftemp = grok.PageTemplateFile('templates/staffsitelayout.pt')
+    studenttemp = grok.PageTemplateFile('templates/studentsitelayout.pt')
+
 
     @property
@@ -166,9 +169,4 @@
         return 'waeup.Student' in roles
 
-    def tableClass(self):
-        if self.isStudent():
-            return 'yui-t7'
-        return 'yui-t1'
-
     def update(self):
         """Include the resources required by the chosen skin/theme.
@@ -193,2 +191,6 @@
         return
 
+    def render(self):
+        if self.isStudent() or not self.isAuthenticated():
+            return self.studenttemp.render(self)
+        return self.stafftemp.render(self)
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/static/mobile.css
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/static/mobile.css	(revision 6690)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/static/mobile.css	(revision 6690)
@@ -0,0 +1,24 @@
+#primary-navigation li a {
+  font-size:100%;
+  padding-bottom: 0.5em;
+  padding-left: 0.5em;
+  padding-right: 0.5em;
+  padding-top: 0.5em;
+}
+
+#user-navigation li a {
+  font-size: 86%;
+  padding-bottom: 0.5em;
+  padding-left: 0.5em;
+  padding-right: 0.5em;
+  padding-top: 0.8em;
+}
+
+#hd {
+  padding-left:0.3em;
+  padding-right:0.3em;
+}
+
+#bd {
+  padding:0.6em;
+}
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/static/waeup-base.css
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/static/waeup-base.css	(revision 6689)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/static/waeup-base.css	(revision 6690)
@@ -52,4 +52,9 @@
 }
 
+
+.block {
+    margin-bottom: 0.5em;
+}
+
 .block .bd {
     padding-bottom: 1em;
@@ -62,4 +67,9 @@
 .wfstatus {
   float: right;
+}
+
+.studentmenu {
+  text-align: center;
+  line-height: 2;
 }
 
Index: in/waeup.sirp/trunk/src/waeup/sirp/browser/templates/sitelayout.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/sitelayout.pt	(revision 6689)
+++ 	(revision )
@@ -1,119 +1,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
-  <head>
-    <title>WAeUP - your way up
-    </title>
-    <!--base href="http://localhost:8080/app/@@page"
-     tal:attributes="href python: view.url(layout.site)" / -->
-    <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
-    <meta name="robots" content="index, follow" />
-    <link rel="shortcut icon" tal:attributes="href static/favicon.ico" type="image/x-icon" />
-    <link rel="alternate" type="application/rss+xml" title="RSS"
-        href="http://www.example.net/feed.rss"
-        tal:attributes="title string:RSS feed of ${layout/getAppTitle};
-            href python: view.url(layout.site, 'feed.rss')" />
-  </head>
-  <body class="rounded yui-skin-sam">
-    <div id="doc3" tal:attributes= "class layout/tableClass">
-      <div id="hd" role="banner">
-        <div id="hd">
-          <h1 id="logo">
-            <a href="" tal:attributes="href view/application_url">
-              <span class="uni-logo">
-              </span> </a>
-            <span id="uni-title" tal:content="layout/getAppTitle"> Sample University
-            </span> </h1>
-          <div id="navigation" class="yui-navset" style="text-align:right;">
-            <ul id="primary-navigation" tal:condition="not: layout/isStudent">
-              <tal:primary_nav content="structure provider:primary_nav" />
-            </ul>
-            <ul id="primary-navigation" tal:condition="layout/isStudent">
-              <tal:primary_nav content="structure provider:primary_nav_student" />
-            </ul>
-            <ul id="user-navigation" tal:condition="layout/isAuthenticated">
-              <li>
-              <a href="#" tal:attributes="href python: view.url(layout.site, '@@contactadmin')">
-                  Contact
-              </a>
-              </li>
-              <li>
-              <a href="#" tal:attributes="href python: view.url(context, '@@logout')">Logout</a>
-              </li>
-            </ul>
-            <div class="clear">
-            </div>
-          </div>
-        </div>
-      </div>
-      <div id="bd" role="main">
-        <span tal:condition="python: layout.isAuthenticated() and not layout.isStudent()"
-              tal:content="structure provider:breadcrumbs" />
-
-        <div class="yui-b" tal:condition="not: layout/isStudent">
-          <div class="block" tal:condition="layout/getStudentName">
-            <div class="hd">
-              <h2 tal:content="layout/getStudentName">Student name</h2>
-            </div>
-            <div class="bd">
-              <tal:left content="structure provider:left_studentmanage" />
-            </div>
-          </div>
-          <div class="block">
-            <div class="hd">
-              <h2 tal:content="layout/getUserTitle">Username</h2>
-            </div>
-            <div class="bd">
-              <tal:left content="structure provider:left" />
-            </div>
-          </div>
-        </div>
-
-        <div class="yui-b" tal:condition="layout/isStudent">
-          <div class="block" tal:condition="layout/getStudentName">
-            <div>
-              <tal:left content="structure provider:top_student" />
-            </div>
-          </div>
-        </div>
-
-        <div id="yui-main">
-          <div class="yui-b">
-            <div class="yui-g">
-              <div class="block">
-                <div class="hd" tal:condition="not: layout/isStudent">
-                  <span tal:content="view/title"> THE CONTENT TITLE </span>
-                  <span tal:condition="layout/getStudentName" class="wfstatus">
-                  Sudent Id: <span tal:content="python:context.getStudent().student_id">Student Id</span>
-                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
-                  Registration State: <span tal:content="python:context.getStudent().state">State</span>
-                  </span>
-                </div>
-                <div class="bd">
-                  <div class="actionbar">
-                    <tal:actionbar content="structure provider:actionbar" />
-                  </div>
-                  <div class="alert warning ui-state-error"
-                      tal:define="message context/@@messages"
-                      tal:condition="python: len(message)>11">
-                    <span class="ui-icon ui-icon-alert">A
-                    </span>
-                    <span tal:content="structure message">
-                    </span>
-                  </div>
-                  <div tal:replace="structure view/content"> THE CONTENT
-                  </div>
-                </div>
-              </div>
-            </div>
-          </div>
-        </div>
-
-      </div>
-      <div id="ft" role="contentinfo">
-        <p>Student Information and Registration Portal<br />
-            Copyright &copy; WAeUP Group, 2008-2011
-        </p>
-      </div>
-    </div>
-  </body>
-</html>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/staffsitelayout.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/staffsitelayout.pt	(revision 6690)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/staffsitelayout.pt	(revision 6690)
@@ -0,0 +1,114 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
+  <head>
+    <title>WAeUP - your way up
+    </title>
+    <!--base href="http://localhost:8080/app/@@page"
+     tal:attributes="href python: view.url(layout.site)" / -->
+    <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
+    <meta name="robots" content="index, follow" />
+    <link rel="shortcut icon" tal:attributes="href static/favicon.ico" type="image/x-icon" />
+    <link rel="alternate" type="application/rss+xml" title="RSS"
+        href="http://www.example.net/feed.rss"
+        tal:attributes="title string:RSS feed of ${layout/getAppTitle};
+            href python: view.url(layout.site, 'feed.rss')" />
+
+  </head>
+  <body class="rounded yui-skin-sam">
+    <div id="doc3" class="yui-t1">
+      <div id="hd" role="banner">
+        <div id="hd">
+          <h1 id="logo">
+            <a href="" tal:attributes="href view/application_url">
+              <span class="uni-logo">
+              </span> </a>
+            <span id="uni-title" tal:content="layout/getAppTitle"> Sample University
+            </span> </h1>
+          <div id="navigation" class="yui-navset" style="text-align:right;">
+            <ul id="primary-navigation">
+              <tal:primary_nav content="structure provider:primary_nav" />
+            </ul>
+            <ul id="user-navigation">
+              <li tal:condition="not: layout/isAuthenticated">
+              <a href="#" tal:attributes="href python: view.url(layout.site, 'login')">
+                  Login
+              </a>
+              </li>
+              <li tal:condition="layout/isAuthenticated">
+              <a href="#" tal:attributes="href python: view.url(layout.site, '@@contactadmin')">
+                  Contact
+              </a>
+              </li>
+              <li tal:condition="layout/isAuthenticated">
+              <a href="#" tal:attributes="href python: view.url(context, '@@logout')">Logout</a>
+              </li>
+            </ul>
+            <div class="clear">
+            </div>
+          </div>
+        </div>
+      </div>
+      <div id="bd" role="main">
+        <span tal:condition="python: layout.isAuthenticated()"
+              tal:content="structure provider:breadcrumbs" />
+
+        <div class="yui-b">
+          <div class="block" tal:condition="layout/getStudentName">
+            <div class="hd">
+              <h2 tal:content="layout/getStudentName">Student name</h2>
+            </div>
+            <div class="bd">
+              <tal:left content="structure provider:left_studentmanage" />
+            </div>
+          </div>
+          <div class="block" tal:condition="layout/isAuthenticated">
+            <div class="hd">
+              <h2 tal:content="layout/getUserTitle">Username</h2>
+            </div>
+            <div class="bd">
+              <tal:left content="structure provider:left" />
+            </div>
+          </div>
+        </div>
+
+        <div id="yui-main">
+          <div class="yui-b">
+            <div class="yui-g">
+              <div class="block">
+                <div class="hd" tal:condition="python: layout.isAuthenticated()">
+                  <span tal:content="view/title"> THE CONTENT TITLE </span>
+                  <span tal:condition="layout/getStudentName" class="wfstatus">
+                  Sudent Id: <span tal:content="python:context.getStudent().student_id">Student Id</span>
+                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
+                  Registration State: <span tal:content="python:context.getStudent().state">State</span>
+                  </span>
+                </div>
+                <div class="bd">
+                  <div class="actionbar">
+                    <tal:actionbar content="structure provider:actionbar" />
+                  </div>
+                  <div class="alert warning ui-state-error"
+                      tal:define="message context/@@messages"
+                      tal:condition="python: len(message)>11">
+                    <span class="ui-icon ui-icon-alert">A
+                    </span>
+                    <span tal:content="structure message">
+                    </span>
+                  </div>
+                  <div tal:replace="structure view/content"> THE CONTENT
+                  </div>
+                </div>
+              </div>
+            </div>
+          </div>
+        </div>
+
+      </div>
+      <div id="ft" role="contentinfo">
+        <p>Student Information and Registration Portal<br />
+            Copyright &copy; WAeUP Group, 2008-2011
+        </p>
+      </div>
+    </div>
+  </body>
+</html>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/studentsitelayout.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/studentsitelayout.pt	(revision 6690)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/studentsitelayout.pt	(revision 6690)
@@ -0,0 +1,128 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
+  <head>
+    <title>WAeUP - your way up
+    </title>
+    <!--base href="http://localhost:8080/app/@@page"
+     tal:attributes="href python: view.url(layout.site)" / -->
+    <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
+    <meta name="robots" content="index, follow" />
+    <meta name="viewport" content="width=320, initial-scale=1, maximum-scale=1"/>
+    <link rel="stylesheet" media="only screen and (max-device-width: 480px)"
+        tal:attributes="href python: view.url(layout.site, '@@/waeup.sirp.browser/mobile.css')" type="text/css" />
+    <link rel="shortcut icon" tal:attributes="href static/favicon.ico" type="image/x-icon" />
+    <link rel="alternate" type="application/rss+xml" title="RSS"
+        href="http://www.example.net/feed.rss"
+        tal:attributes="title string:RSS feed of ${layout/getAppTitle};
+            href python: view.url(layout.site, 'feed.rss')" />
+
+  </head>
+  <body class="rounded yui-skin-sam">
+    <div id="doc3" class="yui-t7">
+      <div id="hd" role="banner">
+        <div id="hd">
+          <h1 id="logo">
+            <a href="" tal:attributes="href view/application_url">
+              <span class="uni-logo">
+              </span> </a>
+            <span id="uni-title" tal:content="layout/getAppTitle"> Sample University
+            </span> </h1>
+          <div id="navigation" class="yui-navset" style="text-align:right;">
+            <ul id="primary-navigation" tal:condition="not: layout/isStudent">
+              <tal:primary_nav content="structure provider:primary_nav" />
+            </ul>
+            <ul id="primary-navigation" tal:condition="layout/isStudent">
+              <tal:primary_nav content="structure provider:primary_nav_student" />
+            </ul>
+            <ul id="user-navigation">
+              <li tal:condition="not: layout/isAuthenticated">
+              <a href="#" tal:attributes="href python: view.url(layout.site, 'login')">
+                  Login
+              </a>
+              </li>
+              <li tal:condition="layout/isAuthenticated">
+              <a href="#" tal:attributes="href python: view.url(layout.site, '@@contactadmin')">
+                  Contact
+              </a>
+              </li>
+              <li tal:condition="layout/isAuthenticated">
+              <a href="#" tal:attributes="href python: view.url(context, '@@logout')">Logout</a>
+              </li>
+            </ul>
+            <div class="clear">
+            </div>
+          </div>
+        </div>
+      </div>
+      <div id="bd" role="main">
+        <span tal:condition="python: layout.isAuthenticated() and not layout.isStudent()"
+              tal:content="structure provider:breadcrumbs" />
+
+        <div class="yui-b" tal:condition="not: layout/isStudent">
+          <div class="block" tal:condition="layout/getStudentName">
+            <div class="hd">
+              <h2 tal:content="layout/getStudentName">Student name</h2>
+            </div>
+            <div class="bd">
+              <tal:left content="structure provider:left_studentmanage" />
+            </div>
+          </div>
+          <div class="block" tal:condition="layout/isAuthenticated">
+            <div class="hd">
+              <h2 tal:content="layout/getUserTitle">Username</h2>
+            </div>
+            <div class="bd">
+              <tal:left content="structure provider:left" />
+            </div>
+          </div>
+        </div>
+
+        <div class="yui-b" tal:condition="layout/isStudent">
+          <div class="block" tal:condition="layout/getStudentName">
+            <div class="studentmenu">
+              <tal:left content="structure provider:top_student" />
+            </div>
+          </div>
+        </div>
+
+        <div id="yui-main">
+          <div class="yui-b">
+            <div class="yui-g">
+              <div class="block">
+                <div class="hd" tal:condition="python: not layout.isStudent() and layout.isAuthenticated()">
+                  <span tal:content="view/title"> THE CONTENT TITLE </span>
+                  <span tal:condition="layout/getStudentName" class="wfstatus">
+                  Sudent Id: <span tal:content="python:context.getStudent().student_id">Student Id</span>
+                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
+                  Registration State: <span tal:content="python:context.getStudent().state">State</span>
+                  </span>
+                </div>
+                <div class="bd">
+                  <div class="actionbar">
+                    <tal:actionbar content="structure provider:actionbar" />
+                  </div>
+                  <div class="alert warning ui-state-error"
+                      tal:define="message context/@@messages"
+                      tal:condition="python: len(message)>11">
+                    <span class="ui-icon ui-icon-alert">A
+                    </span>
+                    <span tal:content="structure message">
+                    </span>
+                  </div>
+                  <div tal:replace="structure view/content"> THE CONTENT
+                  </div>
+                </div>
+              </div>
+            </div>
+          </div>
+        </div>
+
+      </div>
+      <div id="ft" role="contentinfo">
+        <p>Student Information and Registration Portal<br />
+            Copyright &copy; WAeUP Group, 2008-2011
+        </p>
+      </div>
+    </div>
+  </body>
+</html>