Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 6723)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 6724)
@@ -389,5 +389,5 @@
     @property
     def label(self):
-        return u'Login for applicants only'
+        return u"Login for '%s' applicants only" % self.context.title
 
     pnav = 3
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6723)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6724)
@@ -4,6 +4,8 @@
 from zope import schema
 from waeup.sirp.interfaces import IWAeUPObject
+from waeup.sirp.university.vocabularies import study_modes
 from waeup.sirp.students.vocabularies import (
   year_range, lgas_vocab, CertificateSource, GenderSource,
+  entry_session_vocab, study_levels, verdicts,
   )
 
@@ -126,4 +128,32 @@
         )
 
+    current_session = schema.Choice(
+        title = u'Current Session',
+        source = entry_session_vocab,
+        default = None,
+        required = True,
+        )
+
+    current_level = schema.Choice(
+        title = u'Current Level',
+        source = study_levels,
+        default = None,
+        required = True,
+        )
+
+    current_verdict = schema.Choice(
+        title = u'Current Verdict',
+        source = verdicts,
+        default = None,
+        required = True,
+        )
+
+    previous_verdict = schema.Choice(
+        title = u'Previous Verdict',
+        source = verdicts,
+        default = None,
+        required = True,
+        )
+
 class IStudentAccommodation(IWAeUPObject):
     """A container for student accommodation objects.
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py	(revision 6723)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/vocabularies.py	(revision 6724)
@@ -15,5 +15,5 @@
 def entry_sessions():
     curr_year = datetime.now().year
-    year_range = range(curr_year - 5, curr_year + 2)
+    year_range = range(curr_year - 10, curr_year + 2)
     return [('%s/%s' % (year,year+1), '%s' % year) for year in year_range]
 
@@ -22,4 +22,47 @@
 lgas_vocab = SimpleWAeUPVocabulary(
     *sorted([(x[1],x[0]) for x in LGAS]))
+
+# This will become a source with probation and
+# splill-over levels too
+study_levels = SimpleWAeUPVocabulary(
+    ('Pre-Studies',0),
+    ('100 (Year 1)',100),
+    ('200 (Year 2)',200),
+    ('300 (Year 3)',300),
+    ('400 (Year 4)',400),
+    ('500 (Year 5)',500),
+    ('600 (Year 6)',600),
+    ('700 (Year 7)',700),
+    ('800 (Year 8)',800),
+    )
+
+verdicts = SimpleWAeUPVocabulary(
+    ('Successful student','A'),
+    ('Student with carryover courses','B'),
+    ('Student on probation','C'),
+    ('Student who were previously on probation','E'),
+    ('Medical case','F'),
+    ('Absent from examination','G'),
+    ('Withheld results','H'),
+    ('Expelled/rusticated/suspended student','I'),
+    ('Temporary withdrawn from the university','J'),
+    ('Unregistered student','K'),
+    ('Referred student','L'),
+    ('Reinstatement','M'),
+    ('Student on transfer','N'),
+    ('NCE-III repeater','O'),
+    ('New 300 level student','X'),
+    ('No previous verdict','Y'),
+    ('Successful student (provisional)','Z'),
+    ('First Class','A1'),
+    ('Second Class Upper','A2'),
+    ('Second Class Lower','A3'),
+    ('Third Class','A4'),
+    ('Pass','A5'),
+    ('Distinction','A6'),
+    ('Credit','A7'),
+    ('Merit','A8'),
+    )
+
 
 class CertificateSource(BasicContextualSourceFactory):
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py	(revision 6723)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/interfaces.py	(revision 6724)
@@ -9,5 +9,5 @@
     semester,
     application_categories,
-    study_mode,
+    study_modes,
     inst_types,
     CourseSource,
@@ -187,5 +187,5 @@
     study_mode = schema.Choice(
         title = u'Study Mode',
-        vocabulary = study_mode,
+        vocabulary = study_modes,
         default = u'ug_ft',
         required = True,
Index: main/waeup.sirp/trunk/src/waeup/sirp/university/vocabularies.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/university/vocabularies.py	(revision 6723)
+++ main/waeup.sirp/trunk/src/waeup/sirp/university/vocabularies.py	(revision 6724)
@@ -44,5 +44,5 @@
     )
 
-study_mode = SimpleWAeUPVocabulary(
+study_modes = SimpleWAeUPVocabulary(
     ('UME Full Time','ume_ft'),
     ('Direct Entry Full Time','de_ft'),